OpenTTD Source: src/newgrf_roadtype.h File Reference

OpenTTD Source 14.0-beta3

Data Structures | Functions
newgrf_roadtype.h File Reference
`#include "road.h"`
`#include "newgrf_commons.h"`
`#include "newgrf_spritegroup.h"`

Go to the source code of this file.

## Data Structures
struct | RoadTypeScopeResolver
| Resolver for the railtype scope. More...
struct | RoadTypeResolverObject
| Resolver object for road types. More...

## Functions
SpriteID | GetCustomRoadSprite (const RoadTypeInfo *rti, TileIndex tile, RoadTypeSpriteGroup rtsg, TileContext context=TCX_NORMAL, uint *num_results=nullptr)
| Get the sprite to draw for the given tile. More...
RoadType | GetRoadTypeTranslation (RoadTramType rtt, uint8_t tracktype, const GRFFile *grffile)
| Translate an index to the GRF-local road/tramtype-translation table into a RoadType. More...
uint8_t | GetReverseRoadTypeTranslation (RoadType roadtype, const GRFFile *grffile)
| Perform a reverse roadtype lookup to get the GRF internal ID. More...

## Detailed Description

NewGRF handling of road types.

Definition in file newgrf_roadtype.h.

## Function Documentation

## ◆ GetCustomRoadSprite()

SpriteID GetCustomRoadSprite | ( | const RoadTypeInfo * | rti,
|  | TileIndex | tile,
|  | RoadTypeSpriteGroup | rtsg,
|  | TileContext | context,
|  | uint * | num_results
| ) |  |

Get the sprite to draw for the given tile.

Parameters

  | rti | The road type data (spec).
  | tile | The tile to get the sprite for.
  | rtsg | The type of sprite to draw.
  | content | Where are we drawing the tile?
  [out] | num_results | If not nullptr, return the number of sprites in the spriteset.

Returns
  The sprite to draw.

Definition at line 101 of file newgrf_roadtype.cpp.

Referenced by DrawRoadOverlays(), and GetBridgeRoadCatenary().

## ◆ GetReverseRoadTypeTranslation()

uint8_t GetReverseRoadTypeTranslation | ( | RoadType | roadtype,
|  | const GRFFile * | grffile
| ) |  |

Perform a reverse roadtype lookup to get the GRF internal ID.

Parameters

  roadtype | The global (OpenTTD) roadtype.
  grffile | The GRF to do the lookup for.

Returns
  the GRF internal ID.

Definition at line 153 of file newgrf_roadtype.cpp.

## ◆ GetRoadTypeTranslation()

RoadType GetRoadTypeTranslation | ( | RoadTramType | rtt,
|  | uint8_t | tracktype,
|  | const GRFFile * | grffile
| ) |  |

Translate an index to the GRF-local road/tramtype-translation table into a RoadType.

Parameters

  rtt | Whether to index the road- or tramtype-table.
  tracktype | Index into GRF-local translation table.
  grffile | Originating GRF file.

Returns
  RoadType or INVALID_ROADTYPE if the roadtype is unknown.

Definition at line 123 of file newgrf_roadtype.cpp.

References INVALID_ROADTYPE.